# ExecBase
.set	MainInterface,632

# Exec Interface
.set	Obtain,60
.set	Release,64
.set	OpenLibrary,424
.set	CloseLibrary,428
.set	GetInterface,448
.set	DropInterface,456

# DOS Interface
.set	Write,88
.set	Output,96


.macro	CALLOS	# Interface register, function offset
	lwz	r0,\2(\1)
	mr	r3,\1
	mtctr	r0
	bctrl
.endm


	.text

	.global	_start
_start:
	mflr	r0
	stw	r0,4(r1)
	stwu	r1,-32(r1)
	stmw	r28,8(r1)

	# initialize data pointer
	bl	initbase
initbase:
	mflr	r31			# r31 initbase

	# get Exec-Interface
	lwz	r30,MainInterface(r5)	# r30 IExec

	# IExec->Obtain()
	CALLOS	r30,Obtain

	# open dos.library and get DOS-Interface
	# IExec->OpenLibrary("dos.library",50)
	addi	r4,r31,dos_name-initbase
	li	r5,50
	CALLOS	r30,OpenLibrary
	mr.	r28,r3			# r28 DOSBase
	beq	release_exec

	# IExec->GetInterface(DOSBase,"main",1,0)
	mr	r4,r28
	addi	r5,r31,main_name-initbase
	li	r6,1
	li	r7,0
	CALLOS	r30,GetInterface
	mr.	r29,r3			# r29 IDOS
	beq	close_dos

	# IDOS->Output()
	CALLOS	r29,Output

	# IDOS->Write(stdout,"Hello World!\n",13)
	mr	r4,r3
	addi	r5,r31,hello_world-initbase
	li	r6,hello_world_end-hello_world
	CALLOS	r29,Write

	# IExec->DropInterface(IDOS)
	mr	r4,r29
	CALLOS	r30,DropInterface

close_dos:
	# IExec->CloseLibrary(DOSBase)
	mr	r4,r28
	CALLOS	r30,CloseLibrary

release_exec:
	# IExec->Release()
	CALLOS	r30,Release

	# exit(0)
	li	r3,0
	lmw	r28,8(r1)
	addi	r1,r1,32
	lwz	r0,4(r1)
	mtlr	r0
	blr

dos_name:
	.string	"dos.library"
main_name:
	.string	"main"
hello_world:
	.byte	"Hello World!",10
hello_world_end:
